* ---------------------------------------------------------------- col_rat
      Program col_rat

* Makes a file with ratios of columns from specified files

* Assumes that each file has a column representing the abscissa and one
* for the ordinate, and checks to make sure that the abscissa values are the 
* same. 

*!Control file for program Col_Rat
*!Output file name:
* col_rat.col
*!nlines to skip in reference file to get to data:
* 3
*!ncol for abscissa, ordinate:
* 1 2
*!File to use as the reference:
* file_ref.col
*!nlines to skip to get to data:
* 3
*!ncol for abscissa, ordinate:
* 1 2
*!COL file (assume in col format; "STOP" in any column, any case, to quit)
* file1_in.col
* file2_in.col
* file3_in.col
*StoP

* Dates: 02/06/04 - Written by D. Boore, based on Fas_Avg
*        02/10/04 - read column numbers for abscissa and ordinate
 
      character comments(200)*80, buf_c*80, buf4*4
      
      real x_ref(10000), x_in(10000), 
     :  y_ref(10000), y_in(10000,30), dum(10)

      character f_ref*60, f_in*60, f_out*60
      character colhead(32)*13

      character frmt_c*11

      character f_ctl*40
      logical f_ctl_exist

      twopi = 2.0*4.0*atan(1.)

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = col_rat.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'col_rat.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')
      write(*,'(a)') ' f_ctl = '//f_ctl(1:nc_f_ctl)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call trim_c(f_out, nc_f_out)
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out(1:nc_f_out),status='unknown')
      write(*,'(a)') ' f_out = '//f_out(1:nc_f_out)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) nlines_skip_ref

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) ncol_abs_ref, ncol_ord_ref

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      f_ref = ' '
      read(nu_ctl,'(a)') f_ref
      call trim_c(f_ref, nc_f_ref)
      call get_lun(nu_ref)
      open(unit=nu_ref,file=f_ref(1:nc_f_ref),status='unknown')
      write(*,'(a)') ' f_ref = '//f_ref(1:nc_f_ref)
      call skip(nu_ref,nlines_skip_ref)  !   skip headers
      nx_ref = 0
111   continue
      read(nu_ref,*,end=222) 
     :      (dum(i),i=1, max0(ncol_abs_ref, ncol_ord_ref))
      nx_ref = nx_ref + 1     
      x_ref(nx_ref) = dum(ncol_abs_ref)
      y_ref(nx_ref) = dum(ncol_ord_ref)
      go to 111
222   continue

      colhead(1)(1:13) = ' ...........x'

      n2 = min0(nc_f_ref, 12)
      colhead(2)(1:13) = ' ............'
      colhead(2)(13-n2+1:13) = f_ref(1:n2)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) nlines_skip_in

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) ncol_abs_in, ncol_ord_in

      call skipcmnt(nu_ctl,comments,nc_cmnts)


      ifile = 0

1000  continue

      buf_c = ' '
      read(nu_ctl,'(a)') buf_c
      call trim_c(buf_c,nc_buf)
      buf4 = ' '
      buf4 = buf_c(1:4)
      call upstr(buf4)
      if(buf4 .eq. 'STOP') then
         close(nu_ctl)
         go to 555
         stop
      end if

      f_in = ' '
      read(nu_ctl,'(a)') f_in
      call trim_c(f_in, nc_f_in)
      call get_lun(nu_in)
      open(unit=nu_in,file=f_in(1:nc_f_in),status='unknown')
      write(*,'(a)') ' f_in = '//f_in(1:nc_f_in)

* Read the input file:

      call skip(nu_in,nlines_skip_in)  !   skip headers
      nx_in = 0
333   continue
      read(nu_in,*,end=444) 
     :      (dum(i),i=1, max0(ncol_abs_in, ncol_ord_in))
     
     
      
      nx_in = nx_in + 1     

*      write(*,*) nx_in, ifile+1, 
*     :      (i, dum(i),i=1, max0(ncol_abs_in, ncol_ord_in))

      x_in(nx_in) = dum(ncol_abs_in)
      y_in(nx_in, ifile+1) = dum(ncol_ord_in)

      if (x_in(nx_in) .ne. x_ref(nx_in)) then
        write(*,'(a)') ' Error ---  x_in is not the same as x_ref'//
     :   '; nx_in, x_in, x_ref = '
        write(*,*) nx_in, x_in(nx_in), x_ref(nx_in)
        write(*,'(a)') ' Skipping to the next file'
        close(nu_in)
        go to 1000
      end if
      
      go to 333
444   continue

      ifile = ifile + 1

      n2 = min0(nc_f_in, 12)
      colhead(ifile+2)(1:13) = ' ............'
      colhead(ifile+2)(13-n2+1:13) = f_in(1:n2)

      close(nu_in)

      goto 1000 ! go back for another input file

555   continue

* Construct column heads, see smc2asc or smc2rs

      frmt_c = ' '
      frmt_c = '(xx(a13))'

      write(frmt_c(2:3),'(i2)') ifile + 2
      write(nu_out, frmt_c) (colhead(j), j = 1, ifile + 2)


 
*! should check for div 0
      do i = 1, nx_ref
        write(nu_out,'(1p,33(1x,e12.5))')
     :     x_ref(i),y_ref(i),(y_in(i,j)/y_ref(i),j=1,ifile)
      end do

      close(nu_out)

      end
* ---------------------------------------------------------------- col_rat

      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\avevar.for'

 