      Program smc_sort

* Reads a list of smc files made with the command dir/on/b *.smc > smc.lst
* and rewrites the list, sorting so that the uncorr, acc, vel, dis files
* are in order.  The use?  Use in building a control file for smctsplt.

* Assumes groups of 4 files: u,a,v,d.  

* Control file:
*!Control file for program SMC_SORT
*!Name of output file:
* smc_sort.out
*!List of smc files (assumes groups of 4):
* file1_a.smc
* file1_d.smc
* file1_v.smc
* file1_u.smc
* file2_a.smc
* file2_d.smc
* file2_v.smc
* file2_u.smc
*SToP 

* Dates: 04/25/01 - Written by D.M. Boore

      character f_ctl*40, f_out*40, f(4)*40, buf*80, 
     :          comments(20)*80, buf4*4, stem_end*1

      logical f_ctl_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') stop
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skipcmnt(nu_ctl,comments,ncomments)

      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out,status='unknown')

      call skipcmnt(nu_ctl,comments,ncomments)

1000  continue

* Work with groups of 4:
      do i = 1, 4
        buf = ' '
        read(nu_ctl,'(a)') buf
        call trim_c(buf,nc_buf)
        buf4 = ' '
        buf4 = buf(1:4)
        call upstr(buf4)
        if(buf4 .eq. 'STOP') then
          close(nu_out)
          stop
        end if

        indx = index(buf,'.') - 1
        stem_end = ' '
        stem_end = buf(indx:indx)
        call upstr(stem_end)

        if(stem_end .eq. 'U') then
          f(1) = ' '
          f(1) = buf
        else if(stem_end .eq. 'A') then
          f(2) = ' '
          f(2) = buf
        else if(stem_end .eq. 'V') then
          f(3) = ' '
          f(3) = buf
        else if(stem_end .eq. 'D') then
          f(4) = ' '
          f(4) = buf
        else
          write(*,'(3a)') ' stem_end = ', stem_end, 
     :                   '; not U,A,V, or D------ QUITTING!'
          close(nu_out)
          stop
        end if
      end do
      do i = 1, 4
        write(nu_out,'(a)') f(i)
      end do

      go to 1000

      end

      include '\forprogs\get_lun.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skipcmnt.for'

