* ---------------------------------------------------------------- fas_avg
      Program Fas_Avg

* Reads a col file made by smc2fs2 and computes and prints out
* the average and standard average of the mean, using linear averages.

* The next line is the first line in a sample control file:
*!Control file for program FAS_Avg
*!Output file name:
* fas_avg.sum
*!FAS file (assume in col format; "STOP" in any column, any case, to quit)
* file1_in.col
* file2_in.col
* file3_in.col
*StoP

* Dates: 12/29/03 - Written by D. Boore, based on PSV_Avg
*        02/10/04 - Added computation of geometric mean
 
      character comments(200)*80, buf_c*80, buf4*4
      
      real freq(10000,30), fas(10000,30), work(30), workl(30)

      character f_fs*60, f_out*60
      character header(26)*12, damp_c*2

      integer nfreq(30)

      character f_ctl*40
      logical f_ctl_exist

      twopi = 2.0*4.0*atan(1.)

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = fas_avg.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'fas_avg.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')
      write(*,'(a)') ' f_ctl = '//f_ctl(1:nc_f_ctl)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call trim_c(f_out, nc_f_out)
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out(1:nc_f_out),status='unknown')
      write(*,'(a)') ' f_out = '//f_out(1:nc_f_out)

      call skipcmnt(nu_ctl,comments,nc_cmnts)

      ifile = 0

1000  continue

      buf_c = ' '
      read(nu_ctl,'(a)') buf_c
      call trim_c(buf_c,nc_buf)
      buf4 = ' '
      buf4 = buf_c(1:4)
      call upstr(buf4)
      if(buf4 .eq. 'STOP') then
         close(nu_ctl)
         go to 555
         stop
      end if

      f_fs = ' '
      f_fs = buf_c(1:nc_buf)
      call trim_c(f_fs, nc_f_fs)
      call get_lun(nu_fs)
      open(unit=nu_fs,file=f_fs(1:nc_f_fs),status='unknown')
      write(*,'(a)') '   f_fs = '//f_fs(1:nc_f_fs)

* Read the input file:

      ifile = ifile + 1
     
      nfreq(ifile) = 0

      call skip(nu_fs,1)  !   skip first line
* Get nfreq:
      read(nu_fs,*) nfreq(ifile) 
      call skip(nu_fs,1)  !   skip third line

* Read spectra:
      do i = 1, nfreq(ifile)
        read(nu_fs,*) 
     :   freq(i, ifile), fas(i, ifile)
      end do
      close(nu_fs)

      write(*,'(a,1x,i6,1x,i6)') 
     :       ' ifile, nfreq(ifile)=', ifile, nfreq(ifile)

      goto 1000 ! go back for another fs file

555   continue

      write(nu_out,'(t9,a, 
     :               t23,a, t32,a, t44,a, 
     :               t59,a, t68,a, t80,a)')
     :      'freq', 
     :             'AM', 'AM-SE', 'AM+SE', 
     :             'GM', 'GM/SE', 'GM*SE'
 
      do i = 1, nfreq(1)
* One check for equality of freq:
        do j = 2, ifile
          if (freq(i,j) .ne. freq(i,1)) then
            write(*,'(a,2(1x,i3),a)') ' ERROR.  freq for i, j = ',
     :         i, j, ' not equal to ifile 1 freq '
            close (nu_out)
            stop
          end if
        end do
* Find mean and seom
        do j = 1, ifile
          work(j) = fas(i, j)
          workl(j) = alog10(fas(i,j)) 
        end do
        call avevar(work,ifile,am,var)
        call avevar(workl,ifile,avel,varl)
        gm = 10.0**avel
        alogse = 10.0**sqrt(varl/ifile)
        write(nu_out,'(1p,7(1x,e11.4))') 
     :          freq(i,1), 
     :          am, am - sqrt(var/ifile), am + sqrt(var/ifile),
     :          gm, gm/alogse,            gm*alogse

      end do

      close(nu_out)

      end
* ---------------------------------------------------------------- fas_avg

      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\avevar.for'

