* ---------------------------------------------------------------- psv_avg
      Program PSV_Avg

* Reads a col file made by blpadflt and computes and prints out
* the average and standard average of the mean, using both linear and log
* averages.

* The next line is the first line in a sample control file:
*!Control file for program PSV_Avg
*!Output file name:
* psv_avg.sum
*!accel_file ("STOP" in any column, any case, to quit)
* file1_in.smc
* file2_in.smc
* file3_in.smc
*StoP

* Dates: 12/05/03 - Written by D. Boore, based on SMC2RS and GetAvgSA
 
      character comments(200)*80, buf_c*80, buf4*4
      
      real per(500,30), psv(500,30), work(30), workl(30)
      character f_rs*60, f_out*60
      character header(26)*12, damp_c*2

      integer nper(30)

      character f_ctl*40
      logical f_ctl_exist

      twopi = 2.0*4.0*atan(1.)

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = psv_avg.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'psv_avg.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')
      write(*,'(a)') ' f_ctl = '//f_ctl(1:nc_f_ctl)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call trim_c(f_out, nc_f_out)
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out(1:nc_f_out),status='unknown')
      write(*,'(a)') ' f_out = '//f_out(1:nc_f_out)

      call skipcmnt(nu_ctl,comments,nc_cmnts)

      ifile = 0

1000  continue

      buf_c = ' '
      read(nu_ctl,'(a)') buf_c
      call trim_c(buf_c,nc_buf)
      buf4 = ' '
      buf4 = buf_c(1:4)
      call upstr(buf4)
      if(buf4 .eq. 'STOP') then
         close(nu_ctl)
         go to 555
         stop
      end if

      f_rs = ' '
      f_rs = buf_c(1:nc_buf)
      call trim_c(f_rs, nc_f_rs)
      call get_lun(nu_rs)
      open(unit=nu_rs,file=f_rs(1:nc_f_rs),status='unknown')
      write(*,'(a)') '   f_rs = '//f_rs(1:nc_f_rs)

* Read the input file:

      ifile = ifile + 1
     
      nper(ifile) = 0

      call skip(nu_rs,1)  !   skip first line

888   continue
      read(nu_rs,*, end = 444) 
     :   per(nper(ifile)+1, ifile), dum, psv(nper(ifile)+1, ifile)
      nper(ifile) = nper(ifile) + 1
      go to 888
444   continue
      close(nu_rs)

      goto 1000 ! go back for another rs file

555   continue

      write(nu_out,'(t10,a, 
     :               t23,a, t32,a, t44,a, 
     :               t59,a, t68,a, t80,a)')
     :      'PER', 
     :             'AM', 'AM-SE', 'AM+SE', 
     :             'GM', 'GM/SE', 'GM*SE'

      do i = 1, nper(1)
* One check for equality of per:
        do j = 2, ifile
          if (per(i,j) .ne. per(i,1)) then
            write(*,'(a,2(1x,i3),a)') ' ERROR.  Period for i, j = ',
     :         i, j, ' not equal to ifile 1 per '
            close (nu_out)
            stop
          end if
        end do
* Find mean and seom
        do j = 1, ifile
          work(j) = psv(i, j)
          workl(j) = alog10(psv(i,j)) 
        end do
        call moment(work,ifile,am,adev,sdev,var,skew,curt)
        call moment(workl,ifile,avel,adevl,sdevl,varl,skewl,curtl)
        gm = 10.0**avel
        alogse = 10.0**sqrt(varl/ifile)
        write(nu_out,'(1p,7(1x,e11.4))') 
     :          per(i,1), 
     :          am, am - sqrt(var/ifile), am + sqrt(var/ifile),
     :          gm, gm/alogse,            gm*alogse
      end do

      close(nu_out)

      end
* ---------------------------------------------------------------- smc2rs

      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\moment.for'

